/* Problem URL: https://codeforces.com/problemset/problem/2127/D */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;

const ll mod = 1e9 + 7;
constexpr int MAXN = 2e5 + 10;
ll fact[MAXN];

void pre()
{
    fact[0] = 1;
    nrep(i, 1, MAXN) {
        fact[i] = fact[i - 1] * i % mod;
    }
}

#define TEST 1

void solve()
{
    int n, m;
    cin >> n >> m;
    if (m != n - 1) {
        while (m--) {
            int a, b;
            cin >> a >> b;
        }
        cout << "0\n";
        return;
    }

    vvi graph(n);
    while (m--) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        graph[a].push_back(b);
        graph[b].push_back(a);
    }

    vi g(n, -1);
    vi gr(n);
    vi cr;

    int c = 0;
    function<bool(int)> dfs = [&](int i) {
        gr[i] = c;
        cr[c]++;
        repv(j, graph[i]){
            if (g[j] == -1) {
                g[j] = g[i] ^ 1;
                if (!dfs(j)) {
                    return false;
                }
                continue;
            }

            if (g[j] == g[i]) {
                return false;
            }
        }

        return true;
    };

    auto fpow = [&](ll a, ll p) {
        ll ans = 1;
        rep(i, 61) {
            if ((p >> i) & 1) {
                (ans *= a) %= mod;
            }
            (a *= a) %= mod;
        }
        return ans;
    };

    int c2 = 0;

    rep(i, n) {
        if (g[i] != -1) {
            continue;
        }

        g[i] = 0;
        cr.push_back(0);
        if (!dfs(i)) {
            cout << "0\n";
            return;
        }
        c2 += cr[c] > 2;
        c++;
    }

    ll ans = fpow(2, c + c2);

    rep(i, n) {
        if (graph[i].size() <= 2) {
            continue;
        }

        int c1 = 0;
        repv(j, graph[i]) {
            c1 += graph[j].size() >= 2;
        }

        if (c1 > 2) {
            cout << "0\n";
            return;
        }

        if (c1 == 0) {
            (ans *= fpow(2, mod - 2)) %= mod;
        }

        (ans *= fact[graph[i].size() - c1]) %= mod;
    }

    cout << ans << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
